<?php

/**
 * Vvveb
 *
 * Copyright (C) 2022  Ziadin Givan
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

return [
	'/rest/'                                       => ['module' => 'index'],

	//posts
	'/rest/post'                                  => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'post'],
	'/rest/post/#post_id#'                        => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post'],
	'/rest/post/{slug}'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post'],
	//revisions
	'/rest/post/#post_id#/revision'              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'post_content_revision'],
	'/rest/post/#post_id#/revision/{created_at}' => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post_content_revision'],
	//pages

	//comments
	'/rest/post/#post_id#/comment'              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'comment'],
	'/rest/post/#post_id#/comment/{created_at}' => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'comment'],

	//media
	'/rest/media'        => ['module' => 'media'],
	'/rest/media/{file}' => ['module' => 'media/media/index'],

	//menus
	'/rest/menu'           => ['module' => 'menu'],
	'/rest/menu/{menu_id}' => ['module' => 'menu/menu/index'],
	//menu-items
	'/rest/menu-item'           => ['module' => 'menu-item'],
	'/rest/menu-item/{menu_id}' => ['module' => 'menu-item/menu-item/index'],

	//taxonomy
	'/rest/taxonomy'           => ['module' => 'taxonomy'],
	'/rest/taxonomy/{menu_id}' => ['module' => 'taxonomy/taxonomy/index'],
	//tags
	//categories

	//users
	'/rest/user'           => ['module' => 'user'],
	'/rest/user/#user_id#' => ['module' => 'user/user/index'],

	//search
	'/rest/search' => ['module' => 'search'],

	//settings
	'/rest/settings' => ['module' => 'settings'],

	//themes
	'/rest/theme'                                  => ['module' => 'theme'],
	'/rest/theme/{slug}'                           => ['module' => 'theme/theme/index'],

	//plugins
	'/rest/plugin'                                  => ['module' => 'plugin'],
	'/rest/plugin/{slug}'                           => ['module' => 'plugin/plugin/index'],

	//languages

	//ecommerce

	//cart
	'/rest/cart'              => ['module' => 'cart/cart/', 'methods' => ['get', 'post']],
	'/rest/cart/{key}'        => ['module' => 'cart/cart', 'methods' => ['get', 'post', 'put', 'patch', 'delete']],
	'/rest/cart/#product_id#' => ['module' => 'cart/cart', 'methods' => ['get', 'post', 'put', 'patch', 'delete']],

	//products
	'/rest/product'              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product'],
	'/rest/product/#product_id#' => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product'],
	'/rest/product/{slug}'       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product'],

	'/rest/admin'                                                    => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'admin'],
	'/rest/admin/#admin_id#'                                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'admin'],
	'/rest/attribute'                                                => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'attribute'],
	'/rest/attribute/#attribute_id#'                                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'attribute'],
	'/rest/attribute_group'                                          => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'attribute_group'],
	'/rest/attribute_group/#attribute_group_id#'                     => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'attribute_group'],
	'/rest/country'                                                  => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'country'],
	'/rest/country/#country_id#'                                     => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'country'],
	'/rest/coupon'                                                   => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'coupon'],
	'/rest/coupon/#coupon_id#'                                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'coupon'],
	'/rest/currency'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'currency'],
	'/rest/currency/#currency_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'currency'],
	'/rest/digital_asset'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'digital_asset'],
	'/rest/digital_asset/#digital_asset_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'digital_asset'],
	'/rest/digital_asset_log'                                        => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'digital_asset_log'],
	'/rest/digital_asset_log/#digital_asset_log_id#'                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'digital_asset_log'],
	'/rest/field'                                                    => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'field'],
	'/rest/field/#field_id#'                                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'field'],
	'/rest/field_group'                                              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'field_group'],
	'/rest/field_group/#field_group_id#'                             => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'field_group'],
	'/rest/language'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'language'],
	'/rest/language/#language_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'language'],
	'/rest/length_type'                                              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'length_type'],
	'/rest/length_type/#length_type_id#'                             => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'length_type'],
	'/rest/manufacturer'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'manufacturer'],
	'/rest/manufacturer/#manufacturer_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'manufacturer'],
	'/rest/media_content'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'media_content'],
	'/rest/media_content/#media_content_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'media_content'],
	'/rest/menu'                                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'menu'],
	'/rest/menu/#menu_id#'                                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'menu'],
	'/rest/option'                                                   => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'option'],
	'/rest/option/#option_id#'                                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'option'],
	'/rest/option_value'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'option_value'],
	'/rest/option_value/#option_value_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'option_value'],
	'/rest/order'                                                    => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'order'],
	'/rest/order/#order_id#'                                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'order'],
	'/rest/order_log'                                                => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'order_log'],
	'/rest/order_log/#order_log_id#'                                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'order_log'],
	'/rest/order_status'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'order_status'],
	'/rest/order_status/#order_status_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'order_status'],
	'/rest/payment_status'                                           => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'payment_status'],
	'/rest/payment_status/#payment_status_id#'                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'payment_status'],
	'/rest/post_content_meta'                                        => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'post_content_meta'],
	'/rest/post_content_meta/#post_content_meta_id#'                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post_content_meta'],
	'/rest/post_content_revision'                                    => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'post_content_revision'],
	'/rest/post_content_revision/#post_content_revision_id#'         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post_content_revision'],
	'/rest/post_meta'                                                => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'post_meta'],
	'/rest/post_meta/#post_meta_id#'                                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'post_meta'],
	'/rest/product_attribute'                                        => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_attribute'],
	'/rest/product_attribute/#product_attribute_id#'                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_attribute'],
	'/rest/product_content_meta'                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_content_meta'],
	'/rest/product_content_meta/#product_content_meta_id#'           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_content_meta'],
	'/rest/product_content_revision'                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_content_revision'],
	'/rest/product_content_revision/#product_content_revision_id#'   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_content_revision'],
	'/rest/product_meta'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_meta'],
	'/rest/product_meta/#product_meta_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_meta'],
	'/rest/product_option'                                           => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_option'],
	'/rest/product_option/#product_option_id#'                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_option'],
	'/rest/product_option_value'                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_option_value'],
	'/rest/product_option_value/#product_option_value_id#'           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_option_value'],
	'/rest/product_question'                                         => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_question'],
	'/rest/product_question/#product_question_id#'                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_question'],
	'/rest/product_review'                                           => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_review'],
	'/rest/product_review/#product_review_id#'                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_review'],
	'/rest/product_review_media'                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_review_media'],
	'/rest/product_review_media/#product_review_media_id#'           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_review_media'],
	'/rest/product_subscription'                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'product_subscription'],
	'/rest/product_subscription/#product_subscription_id#'           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'product_subscription'],
	'/rest/region'                                                   => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'region'],
	'/rest/region/#region_id#'                                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'region'],
	'/rest/region_group'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'region_group'],
	'/rest/region_group/#region_group_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'region_group'],
	'/rest/returns'                                                  => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'return'],
	'/rest/return/#return_id#'                                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'return'],
	'/rest/return_reason'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'return_reason'],
	'/rest/return_reason/#return_reason_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'return_reason'],
	'/rest/return_resolution'                                        => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'return_resolution'],
	'/rest/return_resolution/#return_resolution_id#'                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'return_resolution'],
	'/rest/return_status'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'return_status'],
	'/rest/return_status/#return_status_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'return_status'],
	'/rest/role'                                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'role'],
	'/rest/role/#role_id#'                                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'role'],
	'/rest/setting'                                                  => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'setting'],
	'/rest/setting/#setting_id#'                                     => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'setting'],
	'/rest/setting_content'                                          => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'setting_content'],
	'/rest/setting_content/#setting_content_id#'                     => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'setting_content'],
	'/rest/shipping_status'                                          => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'shipping_status'],
	'/rest/shipping_statuse/#shipping_status_id#'                    => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'shipping_status'],
	'/rest/stock_status'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'stock_status'],
	'/rest/stock_status/#stock_status_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'stock_status'],
	'/rest/subscription'                                             => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'subscription'],
	'/rest/subscription/#subscription_id#'                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'subscription'],
	'/rest/subscription_plan'                                        => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'subscription_plan'],
	'/rest/subscription_plan/#subscription_plan_id#'                 => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'subscription_plan'],
	'/rest/subscription_status'                                      => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'subscription_status'],
	'/rest/subscription_status/#subscription_status_id#'             => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'subscription_status'],
	'/rest/taxonomy'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'taxonomy'],
	'/rest/taxonomy/#taxonomy_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'taxonomy'],
	'/rest/taxonomy_item'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'taxonomy_item'],
	'/rest/taxonomy_item/#taxonomy_item_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'taxonomy_item'],
	'/rest/tax_rate'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'tax_rate'],
	'/rest/tax_rate/#tax_rate_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'tax_rate'],
	'/rest/tax_rule'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'tax_rule'],
	'/rest/tax_rule/#tax_rule_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'tax_rule'],
	'/rest/tax_type'                                                 => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'tax_type'],
	'/rest/tax_type/#tax_type_id#'                                   => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'tax_type'],
	'/rest/user'                                                     => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'user'],
	'/rest/user/#user_id#'                                           => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'user'],
	'/rest/user_addresse'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'user_address'],
	'/rest/user_addresse/#user_address_id#'                          => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'user_address'],
	'/rest/user_groups'                                              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'user_group'],
	'/rest/user_group/#user_group_id#'                               => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'user_group'],
	'/rest/user_wishlist'                                            => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'user_wishlist'],
	'/rest/user_wishlist/#user_wishlist_id#'                         => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'user_wishlist'],
	'/rest/vendor'                                                   => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'vendor'],
	'/rest/vendor/#vendor_id#'                                       => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'vendor'],
	'/rest/voucher'                                                  => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'voucher'],
	'/rest/voucher/#voucher_id#'                                     => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'voucher'],
	'/rest/weight_type'                                              => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'weight_type'],
	'/rest/weight_type/#weight_type_id#'                             => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'weight_type'],

	'/rest/site'           => ['module' => 'default', 'methods' => ['get', 'post'], 'schema' => 'site'],
	'/rest/site/#site_id#' => ['module' => 'default/crud/index', 'methods' => ['get', 'post', 'put', 'patch', 'delete'], 'schema' => 'site'],
];
